<?php
/*******************************************************************************
 *	config.php	The WebSite configuration
 *	Copyright	Terry Barnaby,	BeamWeb,	2021-01-05
 *******************************************************************************
 */

require_once "lib/BConfig.php";

/*
 * PHP settings:
 *
 * To see what PHP settings are possible, including whether they can
 * be set at runtime (ie., when ini_set() occurs), read the PHP
 * documentation at http://www.php.net/manual/en/ini.php#ini.list
 * and take a look at the .htaccess file to see which non-runtime
 * settings are used there. Settings defined here should not be
 * duplicated there so as to avoid conflict issues.
 */
if(0){
ini_set('arg_separator.output',     '&amp;');
ini_set('magic_quotes_runtime',     0);
ini_set('magic_quotes_sybase',      0);
ini_set('session.cache_expire',     200000);
ini_set('session.cache_limiter',    'none');
ini_set('session.cookie_lifetime',  2000000);
ini_set('session.gc_maxlifetime',   200000);
// ini_set('session.save_handler',     'user');
// ini_set('session.use_only_cookies', 1);
// ini_set('session.use_trans_sid',    0);
ini_set('url_rewriter.tags',        '');
}

$config = new BConfig;

$config->init();

$config->forceHttps		= 0;			// Force use of HTTPS
$config->htmlRebaseLinks	= 0;			// Rebase all HTML links to website URL
$config->databaseHost		= "localhost";
$config->databaseName		= "BDS_WEB";
$config->databaseUser		= "bds_web";
$config->databasePassword	= "bds_web";
$config->databasePrefix		= "bds_web_";
$config->siteName		= "bds";
$config->siteTitle		= "Blacknest Data System";
$config->siteMoto		= "";
$config->siteDescription	= "Blacknest Data System";
$config->siteKeywords		= "Blacknest, BDS, Seismic Data";
$config->logo			= "BlacknestLogo.png";
$config->style			= "bds";
$config->siteEmailAddress	= "fred@somewhere";
$config->siteEmailAdmin		= "fred@somewhere";
$config->testEmailAddress	= "fred@somewhere";
$config->emailMembership	= 0;			// Enable use of membership database for email addresses when sending to all or a group
$config->emailSend		= 0;			// Enable/disable the sending of emails
$config->moduleNames		= array("management" => "management",
					"configure" => "config",
					"category" => "category",
					"bds" => "bds",
					//"news" => "news",
					"document" => "document",
					"fileBrowser" => "fileBrowser",
					);
$config->userRoles		= "";
$config->loginRequired		= 0;
$config->loginRegister		= 0;
$config->loginRegisterValidate	= 0;
$config->loginUsernameEmail	= 0;			// Use email address as username
$config->loginNoGroups		= 0;			// No groups in login registration
$config->loginLeftSide		= 1;			// Login in left hand panel
$config->loginOnlyFiles		= "";			// Files accessible to users logged in
$config->membersOnlyFiles	= "";			// Files accessible to members only
$config->noaccessFiles		= "";			// Files not accessible

$config->smsSend		= 0;			// Enable/disable the sending of SMS
$config->smsCost		= 0.06;			// Cost of SMS message
$config->smsUser		= "";			// SMS account user id
$config->smsPassword		= "";			// SMS account password

$config->nochex			= array();
$config->facebook		= array();

$config->aditemsShowHome	= 0;			// Show adverts on home page
$config->aditemsShowAll		= 0;			// Show adverts on all pages
$config->contentViewLhs		= 0;			// Show content view block on LHS

$config->bdsHost		= "localhost";		// The BDS server's host name
$config->bdsUser		= "bdsWeb";		// The BDS server's user name
$config->bdsPassword		= "beam00";		// The BDS server's password

$config->test			= 0;			// Default module test setting
$config->debug			= 0;			// Debug bitmask

if($_SERVER["HTTP_HOST"] == "bds.kingnet"){
	$config->baseDir		= "/src/blacknest/bds/bds/bdsWeb/www";
	$config->baseUrl		= "http://bds.kingnet";
	$config->databaseHost		= "king.kingnet";
	$config->databaseName		= "webSys";
	$config->databaseUser		= "webSys";
	$config->databasePassword	= "webSys";
	$config->databasePrefix		= "bds_";
	$config->bdsHost		= "localhost";			// The BDS server's host name
	//$config->bdsHost		= "beam.beamnet";		// The BDS server's host name
	//$config->bdsHost		= "bds1.beamnet";		// The BDS server's host name
}
if($_SERVER["HTTP_HOST"] == "bds.beam.beamnet"){
	$config->baseDir		= "/src/blacknest/bds/bds/bdsWeb/www";
	$config->baseUrl		= "http://bds.beam.beamnet";
}

// Set include paths
set_include_path($config->baseDir . '/lib' . PATH_SEPARATOR . get_include_path());
set_include_path($config->baseDir . '/lib/tcpdf' . PATH_SEPARATOR . get_include_path());
set_include_path($config->baseDir . '/lib/PhpMailer' . PATH_SEPARATOR . get_include_path());
set_include_path($config->baseDir . '/modules' . PATH_SEPARATOR . get_include_path());

?>
