<?php
/*******************************************************************************
 *	Index.php	Main Page for website
 *	Copyright	Terry Barnaby,	BeamWeb,	2021-01-05
 *******************************************************************************
 */
require_once "config.php";
require_once "BSys.php";

//syslog(LOG_ERR, "Index.php running");

// Force HTTPS access
if($config->forceHttps && (!isset($_SERVER["HTTPS"]) || ($_SERVER["HTTPS"] === "off"))){

	$redirect = "https://" . $_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"];
	header("HTTP/1.1 301 Moved Permanently");
	header("Location: " . $redirect);
	exit();
}

// Get query
if(isset($_GET["q"])){
	$uri = $_GET["q"];
}
else {
	$uri = $_SERVER['REQUEST_URI'];
}

/*******************************************************************************
 *	Debug code
 *******************************************************************************
 */
if(0){
error_log("Beam index.php Uri: {$uri}");
error_log("BaseUrl: {$config->baseUrl}  BaseDir: {$config->baseDir}  BasePath: {$config->basePath}");
error_log("IncludePath: " . get_include_path());
error_log("Server: " . json_encode($_SERVER));
error_log("Post: " . json_encode($_POST));
}

/*******************************************************************************
 *	Main code
 *******************************************************************************
 */
$sys = new BSys($config);
$sys->init();

if(0){
error_log("Beam index.php Uri: {$uri}");
error_log("BaseUrl: {$sys->baseUrl}  BaseDir: {$sys->baseDir}  BasePath: {$sys->basePath}");
error_log("IncludePath: " . get_include_path());
error_log("Server: " . json_encode($_SERVER));
error_log("Post: " . json_encode($_POST));
}

$sys->process($uri);

?>
