// BEAM Ckeditor config for WebSys
CKEDITOR.editorConfig = function( config ) {
	config.language = 'en-gb';
	config.scayt_autoStartup = true;
	config.scayt_disableOptionsStorage = 'lang';
	config.scayt_sLang = 'en_GB';
	// config.uiColor = '#AADC6E';
	// config.image_prefillDimensions = false;
};


function objectPrint(obj){
	console.log("Functions:");
	console.log(Object.keys(obj).filter((key) => typeof this[key] === 'function').sort());
	console.log("Variables:");
	console.log(Object.keys(obj).filter((key) => typeof this[key] !== 'function').sort());
}

// Make images responsive by converting width to be a percentage of the editors width.
// It creates a htmlfilter for the image tag that replaces inline "width" and "style" definitions with
// their corresponding attributes in % and add's (in this example) the "img-responsive" class.
CKEDITOR.on('instanceReady', function (ev) {
	ev.editor.dataProcessor.htmlFilter.addRules( {
	elements : {
		img: function(el){
			//console.log("Process images");

			// Add bootstrap "img-responsive" class to each inserted image
			el.addClass('img-scaling');

			// Remove inline "height" and "width" styles and replace them with their attribute counterparts.in %
			var style = el.attributes.style;
			var match;
			var widthPx = 0;
			var widthPer = 0;
			var tableCell = 0;

			if(style){
				// Get the width from the style.
				match = /(?:^|\s)width\s*:\s*(\d+)px/i.exec(style);
				widthPx = match && match[1];

				match = /(?:^|\s)width\s*:\s*(\d+)%/i.exec(style);
				widthPer = match && match[1];

				// Remove width/height from style
				el.attributes.style = el.attributes.style.replace(/(?:^|\s)width\s*:\s*(\d+).*;?/i, '');
				el.attributes.style = el.attributes.style.replace(/(?:^|\s)height\s*:\s*(\d+).*;?/i, '');
			}

			//alert("Process images1: widthPx: " + widthPx.toString() + " widthPer: " + widthPer.toString());

			// See if the width is set in px
			if(!widthPx && !widthPer && el.attributes.width){
				//console.log("Process images: 3:" + el.attributes.width);
				match = /(\d+)%/i.exec(el.attributes.width);
				if(match){
					match = /(\d+)(.*)/i.exec(el.attributes.width);
					widthPer = match[1];
				}
				else {
					match = /(\d+)(.*)/i.exec(el.attributes.width);
					widthPx = match[1];
				}
			}

			//alert("Process images2: widthPx: " + widthPx.toString() + " widthPer: " + widthPer.toString());

			// If in a table set size based on parents elements size
			//console.log("Process parents"); console.log("Name: " + el.name); objectPrint(el);

			inTable = 0;
			for(p = el.parent; p; p = p.parent){
				//console.log(p.name);
				if(p.name == "td"){
					tableCell = p;
				}
				else if(p.name == "table"){
					inTable = 1;
					break;
				}

			}

			//if(tableCell){
			//	console.log("Tablecell parents"); console.log("Name: " + tableCell.name); objectPrint(tableCell);
			//	alert("Cell");
			//}
			
			// If width is set in px, change to % unless it is in a table
			if(widthPx){
				if(inTable){
					el.attributes.width = widthPx.toString();
					//el.attributes.width = "100%";
					//el.attributes.height = "100%";
				}
				else if(widthPx > 100){
					widthPer = Math.round(100.0 * widthPx / ev.editor.container.$.clientWidth);
					if(widthPer > 100)
						widthPer = 100;

					el.attributes.width = widthPer.toString() + "%";
					//el.attributes.height = width.toString() + "%";;
				}
				else {
					el.attributes.width = widthPx.toString();
				}
			}
			else if(widthPer){
				el.attributes.width = widthPer.toString() + "%";
			}
			else {
				el.attributes.width = "100%";
			}
			
			//alert("Process images done1");

			if(el.attributes.height)
				delete el.attributes.height;

			// Remove the style tag if it is empty
			if(!el.attributes.style)
				delete el.attributes.style;

			//alert("Process images done");
		}
	}
	});
});

// Default tables size of 100%
CKEDITOR.on('dialogDefinition', function(ev){
	var diagName = ev.data.name;
	var diagDefn = ev.data.definition;

	if(diagName === 'table'){
		var infoTab = diagDefn.getContents('info');

		var width = infoTab.get('txtWidth');
		width['default'] = "100%";
	}
});
