/*******************************************************************************
 *	Main.js		Websys main javascript
 *	T.Barnaby,	Beamweb,	2019-04-19
 *	Copyright 2021 BEAM Ltd.
 *******************************************************************************
 */

// Object to hang WebService information
document.ws = {};

var ws_pictureWidth = 1920;
var ws_pictureHeight = 1080;
var ws_mobileWidth = 480;

var ws_imageFiles = "jpg,jpeg,gif,png,wbmp,xbm";
var ws_documentFiles = "pdf,doc,docx,odt,xls,xlsx,ods,pptx,ppt,pptm,odp,sav,svg,html,txt";
var ws_videoFiles = "wmv,mov,mp4,avi";
var ws_miscFiles = "gpx,mp3,txt,patch,zip,gz,h,c,cpp,hpp,bas";

function init_device(){
	//localStorage.setItem("leftSide_state", null);
	
	if(localStorage.getItem("leftSide_state")){
		if(document.getElementById("leftSide"))
			document.getElementById("leftSide").style.display = localStorage.getItem("leftSide_state");
	}
	else if(isMobile){
		if(document.getElementById("leftSide"))
			document.getElementById("leftSide").style.display = "none";
	}
}

function leftside_toggle(){
	w = document.getElementById("leftSide");

	if(w.style.display == "")
		w.style.display = "block";
	if(w.style.display == "block")
		w.style.display = "none";
	else
		w.style.display = "block";

	localStorage.setItem("leftSide_state", w.style.display);
}

function fileExension(filename){
	return ( filename.indexOf('.') > 0 ) ? filename.split('.').pop().toLowerCase() : 'undefined';
}

function createObjDelegate(object, method, arg){
	return function(){
		if(arg !== undefined){
			arguments = [].slice.call(arguments);
			arguments.unshift(arg);
		}
		return method.apply(object, arguments);
	}
}

function inArray(array, elem){
	var len = array.length;
	for(var i = 0; i < len; i++){
		if(array[i] == elem)
			return true;
	}
	return false;
} 

function HtmlNode(p, type, attribs, text){
	node = document.createElement(type);
	p.appendChild(node);
	if(attribs !== undefined){
		for(k in attribs){
			if(k == "className")
				node.className = attribs[k];
			else
				node.setAttribute(k, attribs[k]);
		}
	}
	if(text !== undefined)
		node.appendChild(document.createTextNode(text));

	node.appendNode = function(type, attribs, text){
		return new HtmlNode(this, type, attribs, text);
	}
	node.clearNodes = function(){
		while(this.lastChild)
			this.removeChild(this.lastChild);
	}
	node.setSelected = function(on){
		if(on){
			this.style.color = "white";
			this.style.backgroundColor = "#5b9bda";
		}
		else {
			this.style.color = "";
			this.style.backgroundColor = "";
		}
//		this.className = this.className + " FileIconSelected";
	}

	return node;

}

function eMail(name,domain){
	var href = "mailto:";
	var at = '@';
	document.write('<a href="' +  href + name + at + domain + '">' + name + at + domain + '</a>');
}

function editorTriStateUpdate(obj, vo, change){
//	console.log("editorTriStateUpdate: Value: '" + vo.value + "' change: " + change);
	if(change){
		if(vo.value == ""){
			vo.value = 0;
		}
		else if(vo.value == 0){
			vo.value = 1;
		}
		else {
			vo.value = "";
		}
	}

	if(vo.value == ""){
		obj.indeterminate = 1;
	}
	else if(vo.value == 0){
		obj.checked = 0;
	}
	else {
		obj.checked = 1;
	}

//	console.log("Value: '" + vo.value + "'");
	return true;
}

function editorDateUpdate(formName, name){
//	alert("EditorDateUpdate: FormName: " + formName + "Name: " + name);
	f = document.getElementById(formName);
	dateStr = f[name + "-year"].value + "-" + f[name + "-mon"].value + "-" + f[name + "-day"].value;
	f[name].value = dateStr;
}

function editorDate1(formName, name, value){
	var	dateNow = new Date()
	var	months = new Array("","Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
	var	va = value.split("-");
	
//	alert("Editordate: FormName: " + formName + "Name: " + name + " Value: " + value);
	quotedName = '"' + name + '"';
	
	document.write("<select name='" + name + "-year' onchange='editorDateUpdate(\"" + formName + "\", " + quotedName + ")'>");
	document.write("<option value='0'></option>");
	for(y = dateNow.getFullYear() - 10; y < dateNow.getFullYear() + 10; y++){
		if(y == va[0])
			document.write("<option selected value='" + y + "'>" + y + "</option>");
		else
			document.write("<option value='" + y + "'>" + y + "</option>");
	}
	document.write("</select>");

	document.write("<select name='" + name +"-mon' onchange='editorDateUpdate(\"" + formName + "\", " + quotedName + ")'>");
	for(m = 0; m < 13; m++){
		if(m == va[1])
			document.write("<option selected value='" + m + "'>" + months[m] + "</option>");
		else
			document.write("<option value='" + m + "'>" + months[m] + "</option>");
	}
	document.write("</select>");

	document.write("<select name='" + name +"-day' onchange='editorDateUpdate(\"" + formName + "\", " + quotedName + ")'>");
	for(d = 0; d < 32; d++){
		if(d == 0){
			v = "";
		}
		else {
			v = d;
		}
		if(d == va[2])
			document.write("<option selected value='" + d + "'>" + v + "</option>");
		else
			document.write("<option value='" + d + "'>" + v + "</option>");
	}
	document.write("</select>");

	document.write("<input name='" + name + "' type='hidden' value='" + value + "'>");
}

function editorDate(formName, name, value, help, onChange){
	if(typeof(onChange)==='undefined') onChange = "";
	DateInput(name, false, 'YYYY-MM-DD', value, help, onChange);
}

function editorSelectMultiHorizUpdate(formName, name){
	var	values = "";
	var	options;
	
	f = document.getElementById(formName);
	options = f[name].boptions;
	
//	alert("editorSelectMultiHorizUpdate: FormName: " + formName + " Name: " + name + " N: " + options.length);

	for(i = 0; i < options.length; i++){
		if(f[name + i].checked){
			if(values.length)
				values = values + ",";
			values = values + options[i];
		}
	}
	
	f[name].value = values;
//	alert("editorSelectMultiHorizUpdate: FormName: " + formName + " Name: " + name + " N: " + options.length + " V: " + values);
}

function editorSelectMultiHoriz(formName, name, options, value, help){
	optionList = options.split(",");
	valueList = value.split(",");
	
//	alert("editorSelectMultiHoriz: FormName: " + formName + " Name: " + name + " OptionsLen: " + optionList.length);

	f = document.getElementById(formName);
	
	document.write("<table class='EditSelectMultiHoriz' rules='all' title='" + help + "'><tr>");
	document.write("<input type='hidden' name='" + name + "' value='" + value + "'>");

	for(i in optionList){
		document.write("<td>");
		document.write(optionList[i] + "<br>");
		if(inArray(valueList, optionList[i]))
			ch = "checked";
		else
			ch = "";
			
		document.write("<input type='checkbox' name='" + name + i + "' " + ch + " onchange='editorSelectMultiHorizUpdate(\"" + formName + "\", \"" + name + "\")'>");
		document.write("</td>");
	}
	document.write("</tr></table>\n");
	f[name].boptions = optionList;
}

function editorSelectMultiUpdateCheckbox(formName, name){
	var	values = "";
	var	options;
	
	f = document.getElementById(formName);
	options = f[name].boptions;
	
//	alert("editorSelectMultiHorizUpdate: FormName: " + formName + " Name: " + name + " N: " + options.length);

	for(i = 0; i < options.length; i++){
		if(f[name + i].checked){
			if(values.length)
				values = values + ",";
			values = values + options[i];
		}
	}
	
	f[name].value = values;
//	alert("editorSelectMultiHorizUpdate: FormName: " + formName + " Name: " + name + " N: " + options.length + " V: " + values);
}

function editorSelectMultiCheckbox(formName, name, options, value, help){
	optionList = options.split(",");
	valueList = value.split(",");
	
//	alert("editorSelectMultiHoriz: FormName: " + formName + " Name: " + name + " OptionsLen: " + optionList.length);

	f = document.getElementById(formName);
	
	document.write("<ul class='EditSelectMultiCheckbox' style='list-style-type: none; margin: 0; padding: 0; height: 100px; overflow: auto; overflow-x: hidden;' title='" + help + "'>");
	document.write("<input type='hidden' name='" + name + "' value='" + value + "'>");

	for(i in optionList){
		document.write("<li><label for='" + name + i + "'>");
		if(inArray(valueList, optionList[i]))
			ch = "checked";
		else
			ch = "";
			
		document.write("<input type='checkbox' name='" + name + i + "' id='" + name + i + "'" + ch + " onchange='editorSelectMultiUpdateCheckbox(\"" + formName + "\", \"" + name + "\")'>");
		document.write(optionList[i] + "</label></li>");
	}
	document.write("</ul>\n");
	f[name].boptions = optionList;
}

// Internet Explorer Hacks
function pageWidthMinMax(a, b){
	var	nw = "auto";
	var	w = document.documentElement.clientWidth;
	if(w>=b){nw=b+"px";}
	if(w<=a){nw=a+"px";}
//	alert("DocWidth: " + w + " NewWidth: " + nw);
	return nw;
}

function formOption(list, value){
	ret = "";
	for(var i = 0; i < list.length; i++){
		if(list[i] == value)
			ret = ret + "<option selected>" + list[i] + "</option>";
		else
			ret = ret + "<option>" + list[i] + "</option>";
	}
	return ret;
}

// File uploader with image resize
function FileUploaderForm(name, line, width, height){
	this.name = name;
	this.response = "";

	// alert("FileUploaderForm: Start");

	if(width === undefined) width = ws_pictureWidth;
	if(height === undefined) height = ws_pictureHeight;

	if(line){
		html = "<span id='" + name + "_uploader'><input id='" + name + "_filelist' type='text' readonly size='30'></input>";
		html += "<button id='" + name + "_pickfiles'>Browse</button><input name='fileUploader' value='0' hidden></input></span>";
	}
	else {
		html = "<div id='" + name + "_uploader'><div style='background: #E0DFDE;'><b>Upload pictures and files</b></div>";
		html += "<input id='" + name + "_filelist' size='30'></input>";
		html += "<span><button id='" + name + "_pickfiles'>Add File</button><input type='hidden' name='fileUploader' value='0'></input>";
		html += "</span></div>";
	}
	document.writeln(html);

	this.filelist = document.getElementById(name + '_filelist');
	this.form = this.filelist.form;
	this.formOnSubmit = this.form.onsubmit;

	this.uploader = new plupload.Uploader({
		runtimes : 'html5,flash,browserplus, silverlight',
		file_data_name: this.name,
		browse_button : name + '_pickfiles',
		container: name + '_uploader',
		drop_element: name + '_filelist',
		max_file_size : '250mb',
		url : this.form.action,
		multi_selection: true,
		resize : {width: width, height: height, quality : 90},
		flash_swf_url : '/lib/plupload/plupload.flash.swf',
		multipart: 1,
		multipart_params: { 'fileUploader': '1' },
		silverlight_xap_url : '/lib/plupload/plupload.silverlight.xap',
		filters : [
			{title : "Image files", extensions : ws_imageFiles},
			{title : "Document files", extensions : ws_documentFiles},
			{title : "Video files", extensions : ws_videoFiles},
			{title : "Other files", extensions : ws_miscFiles}
		]
	});
	
	this.addFile = function(up, files){
		// alert("AddFile ok");
		for(var i in files) {
			this.filelist.value = files[i].name + ' (' + plupload.formatSize(files[i].size) + ')';
		}
	}

	this.error = function(up, err){
		alert("Error: " + err.message);
		// this.filelist.innerHTML = "<div>Error: " + err.code + ", Message: " + err.message + (err.file ? ", File: " + err.file.name : "") + "</div>";
	        up.refresh(); // Reposition Flash/Silverlight
	}

	this.progress = function(up, file) {
		this.filelist.value = file.name + ' (' + plupload.formatSize(file.size) + ')' +  file.percent + '%';
	}
	
	this.fileComplete = function(up, file, result){
		//alert("File Uploaded ok: result: " + result.status + " data: " + result.response.substr(0, 64));
		this.response = result.response;
		this.uploader.settings.multipart_params['fileUploader']++;
	}

	this.complete = function(up, files){
		// alert("Files Uploaded complete");
		document.open();
		document.write(this.response);
		document.close();
	}

	this.onsubmit = function(){
		// alert("OnSubmit start: action: " + this.form.action);
		
		// Make sure all CKEitor instalances have setup
		if(typeof CKEDITOR !== 'undefined'){
			for(instance in CKEDITOR.instances)
				CKEDITOR.instances[instance].updateElement();
		}

		// Add other form fields
		for(var i = 0; i < this.form.length; i++){
			v = this.form.elements[i];
			if(v.name){
				this.uploader.settings.multipart_params[v.name] = v.value;
			}
		}
		this.uploader.settings.multipart_params["fileUploader"] = "1";
//		alert("Submit start");

		// Files in queue upload them first
		if(this.uploader.files.length > 0){
			this.uploader.start();
		}
		else {
			//this.formSubmit();
			return true;
		}

		return false;
	}
	
	this.uploader.bind('FilesAdded', createObjDelegate(this, this.addFile));
	this.uploader.bind('Error', createObjDelegate(this, this.error));
	this.uploader.bind('UploadProgress', createObjDelegate(this, this.progress));
	this.uploader.bind('FileUploaded', createObjDelegate(this, this.fileComplete));
	this.uploader.bind('UploadComplete', createObjDelegate(this, this.complete));
	this.form.onsubmit = createObjDelegate(this, this.onsubmit);
	this.uploader.init();
}

// File and Image uploader using plupload with client side image resising
//
function FileUploader(div, name, url, width, height){
	this.name = name;

	if(width === undefined) width = ws_pictureWidth;
	if(height === undefined) height = ws_pictureHeight;

	// Create HTML
	html = "<div id='" + name + "_uploader'><div style='background: #E0DFDE;'><b>Upload pictures and files</b></div>";
	html += "<div id='" + name + "_filelist' style='height:100px;'></div>";
	html += "<span><button id='" + name + "_pickfiles'>Add Files</button><button id='" + name + "_upload'>Upload</button><input type='hidden' name='fileUploader' value='0'></input>";
	html += "</span></div>";
	div.innerHTML = html

	this.filelist = document.getElementById(name + '_filelist');
	this.uploadButton = document.getElementById(name + '_upload');
	this.filesUploaded = new Array();

	this.uploader = new plupload.Uploader({
		runtimes : 'html5,flash,browserplus, silverlight',
		file_data_name: "upload[]",
		browse_button : name + '_pickfiles',
		container: name + '_uploader',
		drop_element: name + '_filelist',
		max_file_size : '250mb',
		url: url,
		multi_selection: 1,
		resize : {width: width, height: height, quality : 90},
		multipart: 1,
		multipart_params: { 'dir': '' },
		silverlight_xap_url : '/lib/plupload/plupload.silverlight.xap',
		flash_swf_url : '/lib/plupload/plupload.flash.swf',
		filters : [
			{title : "Image files", extensions : ws_imageFiles},
			{title : "Document files", extensions : ws_documentFiles},
			{title : "Video files", extensions : ws_videoFiles},
			{title : "Other files", extensions : ws_miscFiles}
		]
	});
	
	this.setDir = function(dir){
		this.uploader.settings.multipart_params["dir"] = dir;
	}
	
	this.setOnComplete = function(onComplete){
		this.onComplete = onComplete;
	}
	
	this.addFile = function(up, files){
//		alert("AddFile ok: " + String(files.length));
		if((this.filelist.innerHTML == "Drag and Drop") || (this.filelist.innerHTML == "Completed"))
			this.filelist.innerHTML = "";

		for(var i in files) {
			this.filelist.innerHTML += files[i].name + ' (' + plupload.formatSize(files[i].size) + ')' + '<br>';
		}
		this.files = files;
		this.filesUploaded = new Array();
	}

	this.progress = function(up, file) {
//		alert("Progress");
		this.filelist.innerHTML = file.name + ' (' + plupload.formatSize(file.size) + ')' +  file.percent + '%';
	}
	
	this.error = function(up, err){
//		alert("Error");
		this.filelist.innerHTML = "<div>Error: " + err.code + ", Message: " + err.message + (err.file ? ", File: " + err.file.name : "") + "</div>";
	        up.refresh(); // Reposition Flash/Silverlight
	}

	this.fileUploaded = function(up, files, info){
//		console.log("fileUploaded: " + files + " : " + info);
		obj = JSON.parse(info.response);
		this.filesUploaded.push(obj);
//		console.log("fileUploaded: " + obj);
	}

	this.complete = function(up, files){
//		console.log("complete: " + files);
		this.filelist.innerHTML = "Completed";
//		browser.refresh();
		if(this.onComplete)
			this.onComplete(this.filesUploaded);
	}
	
	this.upload = function(){
//		alert("Upload to: " + this.uploader.settings.url);
		this.uploader.start();
	}

	this.info = function(up, params){
		if(params.runtime == "html5"){
			this.filelist.innerHTML = "Drag and Drop";
		}
	}
	
	this.uploader.bind('Init', createObjDelegate(this, this.info));
	this.uploader.bind('FilesAdded', createObjDelegate(this, this.addFile));
	this.uploader.bind('UploadProgress', createObjDelegate(this, this.progress));
	this.uploader.bind('Error', createObjDelegate(this, this.error));
	this.uploader.bind('UploadComplete', createObjDelegate(this, this.complete));
	this.uploader.bind('FileUploaded', createObjDelegate(this, this.fileUploaded));
	this.uploadButton.onclick = createObjDelegate(this, this.upload);

	this.uploader.init();
//	this.uploader.refresh();
}

function PictureUploader(name, url, urlBack, useDate=0, useDescription=0, width, height){
	this.name = name;
	this.numFiles = 0;
	this.useDate = useDate;
	this.useDescription = useDescription;

	if(width === undefined) width = ws_pictureWidth;
	if(height === undefined) height = ws_pictureHeight;

	// Create HTML
	html = "<div class='PictureUploader' id='" + name + "_uploader' style='clear: both; float: left;'><div class='PictureUploader_Header'><b>Upload pictures</b></div>";
	html += "<div class='PictureUploader_Filelist' id='" + name + "_filelist' style='clear: both; float: left; overflow: auto;'></div>";
	html += "<div style='clear: both;'>";
	html += "<span><button class='PictureUploader_Button' id='" + name + "_pickfiles'>1: Add Picture</button>";
	html += "<button class='PictureUploader_Button' id='" + name + "_upload' disabled=1>2: Upload</button>";
	html += "<button class='PictureUploader_Button' id='" + name + "_back' onclick='window.location=\"" + urlBack + "\"; return false;'>3: Back</button>";
	html += "<input type='hidden' name='fileUploader' value='0'></input>";
	html += "</span></div></div>";
	document.writeln(html);

	this.filelist = document.getElementById(name + '_filelist');
	this.uploadButton = document.getElementById(name + '_upload');
	this.filesUploaded = new Array();
	this.fileTitles = [];
	this.fileDates = [];
	this.fileDescriptions = [];


	this.uploader = new plupload.Uploader({
		runtimes : 'html5,flash,browserplus, silverlight',
		file_data_name: "upload[]",
		browse_button : name + '_pickfiles',
		container: name + '_uploader',
		drop_element: name + '_filelist',
		max_file_size : '250mb',
		url: url,
		multi_selection: true,
		resize : {width: width, height: height, quality : 90},
		multipart: 1,
		multipart_params: { 'dir': '' },
		silverlight_xap_url : '/lib/plupload/plupload.silverlight.xap',
		flash_swf_url : '/lib/plupload/plupload.flash.swf',
		filters : [
			{title : "Image files", extensions : ws_imageFiles},
			{title : "Document files", extensions : ws_documentFiles},
			{title : "Video files", extensions : ws_videoFiles},
			{title : "Other files", extensions : ws_miscFiles}
		]
	});
	
	this.setDir = function(dir){
		this.uploader.settings.multipart_params["dir"] = dir;
	}
	
	this.setOnComplete = function(onComplete){
		this.onComplete = onComplete;
	}
	
	this.addFile = function(up, files){
//		alert("AddFile: " + String(files.length));
		this.uploadButton.disabled = 0;

		if(this.numFiles == 0)
			this.filelist.innerHTML = "";

		for(var i in files) {
			var pn = name + "_preview" + String(this.numFiles);

			if(this.numFiles == 0){
				this.filelistTable = new HtmlNode(this.filelist, "table");
				hr = new HtmlNode(this.filelistTable, "tr");
				new HtmlNode(hr, "th", {}, "File");
				//new HtmlNode(hr, "th", {}, "Size (MBytes)");
				new HtmlNode(hr, "th", {}, "Picture");
				if(screen.width > ws_mobileWidth){
					if(this.useDate)
						new HtmlNode(hr, "th", {}, "Date");
					if(this.useDescription)
						new HtmlNode(hr, "th", {}, "Title/Description");
					else
						new HtmlNode(hr, "th", {}, "Title");
				}
				else {
					title = "";
					if(this.useDate)
						title += "Date/";

					title += "Title";
					if(this.useDescription)
						title += "/Description";

					new HtmlNode(hr, "th", {}, title);
				}
			}

			hr = new HtmlNode(this.filelistTable, "tr");
			if(files[i].name.length > 16){
				fnl = files[i].name.split(".");
				fn = fnl[0].substring(0, 10) + "*." + fnl[1];
			}
			else {
				fn = files[i].name;
			}
			new HtmlNode(hr, "td", {}, fn);
			//new HtmlNode(hr, "td", {}, plupload.formatSize(files[i].size));
			hi = new HtmlNode(hr, "td");

			if(screen.width > ws_mobileWidth){
				if(this.useDate){
					today = new Date();
					todayStr = today.toISOString().substring(0, 10);
					hn = new HtmlNode(hr, "td");
					this.fileDates.push(new HtmlNode(hn, "input", { type: "date", id: name + "_date" +  String(this.numFiles), value: todayStr}));
				}
				hn = new HtmlNode(hr, "td");
				this.fileTitles.push(new HtmlNode(hn, "input", { type: "text", id: name + "_title" +  String(this.numFiles)}));
				if(this.useDescription)
					this.fileDescriptions.push(new HtmlNode(hn, "textarea", { id: name + "_description" +  String(this.numFiles)}));
			}
			else {
				if(this.useDate){
					today = new Date();
					todayStr = today.toISOString().substring(0, 10);
					hn = new HtmlNode(hr, "td");
					this.fileDates.push(new HtmlNode(hn, "input", { type: "date", id: name + "_date" +  String(this.numFiles), value: todayStr}));
					this.fileTitles.push(new HtmlNode(hn, "input", { type: "text", id: name + "_title" +  String(this.numFiles)}));
				}
				else {
					hn = new HtmlNode(hr, "td");
					this.fileTitles.push(new HtmlNode(hn, "input", { type: "text", id: name + "_title" +  String(this.numFiles)}));
				}
				if(this.useDescription)
					this.fileDescriptions.push(new HtmlNode(hn, "textarea", { id: name + "_description" +  String(this.numFiles)}));

			}
			
			img = new moxie.image.Image();
			img.embedObj = hi;
			img.onload = function() {
				this.embed(this.embedObj, { width: 50, height: 50, crop: false });
			};

			img.onembedded = function() {
				this.destroy();
			};

			img.onerror = function() {
				this.destroy();
			};

			img.load(files[i].getSource());
			files[i].num = this.numFiles;
			this.numFiles += 1;
		}      

		this.filesUploaded = new Array();
	}
	
	this.beforeUpload = function(up, file) {
//		alert("beforeUpload: " + String(file.num));
		this.uploader.settings.multipart_params["title"] = this.fileTitles[file.num].value;
		if(this.useDate)
			this.uploader.settings.multipart_params["date"] = this.fileDates[file.num].value;
		if(this.useDescription)
			this.uploader.settings.multipart_params["description"] = this.fileDescriptions[file.num].value;
	}
	

	this.progress = function(up, file) {
//		alert("Progress");
		this.filelist.innerHTML = file.name + ' (' + plupload.formatSize(file.size) + ')' +  file.percent + '%';
	}
	
	this.error = function(up, err){
//		alert("Error");
		this.filelist.innerHTML = "<div>Error: " + err.code + ", Message: " + err.message + (err.file ? ", File: " + err.file.name : "") + "</div>";
	        up.refresh(); // Reposition Flash/Silverlight
		this.numFiles = 0;
	}

	this.fileUploaded = function(up, files, info){
//		console.log("fileUploaded: " + files + " : " + info);
		obj = JSON.parse(info.response);
		if(obj.error != ""){
			this.filelist.innerHTML = "<div>Error: " + obj.error + "</div>";
			this.numFiles = 0;
			up.stop();
		}
		else {
			this.filesUploaded.push(obj.status);
		}
	}

	this.complete = function(up, files){
//		console.log("complete: " + files);
		this.filelist.innerHTML = "Completed";
		this.numFiles = 0;
		if(this.onComplete)
			this.onComplete(this.filesUploaded);
	}
	
	this.upload = function(){
//		alert("Upload to: " + this.uploader.settings.url);
		this.uploadButton.disabled = 1;
		this.uploader.start();
	}

	this.info = function(up, params){
		if(params.runtime == "html5"){
			this.filelist.innerHTML = "First Drag and Drop picture files here or use Add Pictures button.<br/>";
			if(this.useDate)
				this.filelist.innerHTML += "Optionally you can then add a date, title and description for each picture.<br/>";
			else
				this.filelist.innerHTML += "Optionally you can then add a title for each picture.<br/>";
	
			this.filelist.innerHTML += "Once you have selected the picture files and entered the information, click on the Upload button.";
		}
	}
	
	this.uploader.bind('Init', createObjDelegate(this, this.info));
	this.uploader.bind('FilesAdded', createObjDelegate(this, this.addFile));
	this.uploader.bind('BeforeUpload', createObjDelegate(this, this.beforeUpload));
	this.uploader.bind('UploadProgress', createObjDelegate(this, this.progress));
	this.uploader.bind('Error', createObjDelegate(this, this.error));
	this.uploader.bind('FileUploaded', createObjDelegate(this, this.fileUploaded));
	this.uploader.bind('UploadComplete', createObjDelegate(this, this.complete));
	this.uploadButton.onclick = createObjDelegate(this, this.upload);

	this.uploader.init();
}

function jpegGetOrientation(e, callback){
	var view = new DataView(e.target.result);
	if(view.getUint16(0, false) != 0xFFD8){
		return callback(-2);
	}

	var length = view.byteLength, offset = 2;
	while(offset < length){
		if(view.getUint16(offset+2, false) <= 8) return -1;
		var marker = view.getUint16(offset, false);
		offset += 2;
		if(marker == 0xFFE1){
			if(view.getUint32(offset += 2, false) != 0x45786966){
				return callback(-1);
			}

			var little = view.getUint16(offset += 6, false) == 0x4949;
			offset += view.getUint32(offset + 4, little);
			var tags = view.getUint16(offset, little);
			offset += 2;
			for(var i = 0; i < tags; i++){
				if(view.getUint16(offset + (i * 12), little) == 0x0112){
					return callback(view.getUint16(offset + (i * 12) + 8, little));
				}
			}
		}
		else if((marker & 0xFF00) != 0xFF00){
			break;
		}
		else { 
			offset += view.getUint16(offset, false);
		}
	}
	return callback(-1);
}

// Picure uploader from input
function FormInputPicture(name, type, width=0, height=0, pictureUrl=""){
	this.name = name;

	// alert("FormInputPicture: Start");
	this.orient = 0;
	this.width = width;
	this.height = width;
	if(this.width == 0) this.width = ws_pictureWidth;
	if(this.height == 0) this.height = ws_pictureHeight;

	//this.width = 320;
	//console.log("FormInputPicture: name: " + name + " type: " + type);
	
	if(pictureUrl != ""){
		var pic = "<div class='FormInputPicture_status'><img src='" + pictureUrl + "'></div>";
	}
	else {
		var pic = "";
	}

	if(type == 1){
		html = "<input id='" + name + "_fileinput' name='" + name + "' type='file' accept='image/*' style='display:none;' />";
		html += "<div class='FormInputPicture' id='" + name + "_uploader'> <button id='" + name + "_button'>Select</button> <div class='FormInputPicture_status' id='" + name + "_status'>Drag and drop</div>" + pic + "</div>";
	}
	else if(type == 2){
		html = "<input id='" + name + "_fileinput' name='" + name + "' type='file' accept='image/*' style='display:none;' />";
		html += "<div class='FormInputPicture' id='" + name + "_uploader' style='display: inline-block;'> <button id='" + name + "_button' class='ButtonImageCamera'></button> <div class='FormInputPicture_status_small' id='" + name + "_status'></div>" + pic + "</div>";
	}
	else {
		html = "<input id='" + name + "_fileinput' name='" + name + "' type='file' accept='image/*' style='display:none;' />";
		html += "<div class='FormInputPicture' id='" + name + "_uploader'> <button id='" + name + "_buttonf'>File</button>  <button id='" + name + "_buttonc'>Cam</button> <div class='FormInputPicture_status' id='" + name + "_status'>Drag and drop</div>" + pic + "</div>";
	}
	

	//html += "<div id='debug1' style='width:200px;'></div>";
	//document.writeln(html);
	document.currentScript.insertAdjacentHTML("beforebegin", html);
	
	this.fileinput = document.getElementById(name + '_fileinput');
	this.status = document.getElementById(name + '_status');
	this.button = document.getElementById(name + '_button');
	
	this.form = this.fileinput.form;
	this.canvas = document.createElement("canvas");
	this.img = new Image();
	this.preview = document.createElement("canvas");
	this.fileType = "";
	this.onchangeDisable = 0;
	

	// Used for creating a new FileList in a round-about way
	function FileListItem(a){
		a = [].slice.call(Array.isArray(a) ? a : arguments)
		for (var c, b = c = a.length, d = !0; b-- && d;) d = a[b] instanceof File
		if (!d) throw new TypeError("expected argument to FileList is File or array of File objects")
		for (b = (new ClipboardEvent("")).clipboardData || new DataTransfer; c--;) b.items.add(a[c])
		return b.files
	}
	
	this.droppedFiles = function(event){
		var allTheFiles = event.dataTransfer.files;

		//alert("You've just dropped " + allTheFiles.length + " files");
		event.preventDefault();
	
		for(f = 0; f < allTheFiles.length; f++){
			var fileList = new FileListItem(allTheFiles[f]);
			this.onchangeDisable = 1;
			this.fileinput.files = fileList;
			this.onchangeDisable = 0;
			this.resizePicureFile();
		}
	}

	this.selectFile = function(){
		//alert("SelectFile");
		this.fileinput.click();
		return false;
	}
	
	this.canvasLoaded = function(blob){
		const resizedFile = new File([blob], this.file.name, this.file);
		const fileList = new FileListItem(resizedFile);

		// temporary remove event listener since assigning a new filelist to the input will trigger a new change event...
		this.onchangeDisable = 1;
		this.fileinput.files = fileList;
		this.onchangeDisable = 0;
	}
	
	this.canvasDraw = function(canvas, img, orient, width, height){
		var ctx = canvas.getContext("2d");

		ctx.imageSmoothingQuality = "high";
		ctx.imageSmoothingEnabled = true;
		
		if((img.height < img.width) && (orient > 4)){
			// Old Scaling to fit when Image() didn't do this for us
			if(orient > 4){
				scale = height / img.width;
				xoffset = img.height * scale;
				yoffset = img.width * scale;
				canvas.width = img.height * scale;
				canvas.height = img.width * scale;
			}
			else {
				scale = width / img.width;
				xoffset = img.width * scale;
				yoffset = img.height * scale;
				canvas.width = img.width * scale;
				canvas.height = img.height * scale;
			}
			//console.log("Scale: " + scale + " offset(" + xoffset + ", " + yoffset + ")");
			document.getElementById("debug1").innerHTML = "ImgSize: (" + img.width + "," + img.height + ") Orient: " + orient + " Scale: " + scale.toFixed(2) + " offset(" + xoffset + ", " + yoffset + ")";
		
			// Handle main orientation cases
			switch(orient){
				case 2: ctx.transform(-scale, 0, 0, scale, xoffset, 0); break;
				case 3: ctx.transform(-scale, 0, 0, -scale, xoffset, yoffset); break;
				case 4: ctx.transform(scale, 0, 0, -scale, 0, yoffset); break;
				case 5: ctx.transform(0, scale, scale, 0, 0, 0); break;
				case 6: ctx.transform(0, scale, -scale, 0, xoffset, 0); break;
				case 7: ctx.transform(0, -scale, -scale, 0, xoffset, yoffset); break;
				case 8: ctx.transform(0, -scale, scale, 0, 0, yoffset); break;
				default: ctx.transform(scale, 0, 0, scale, 0, 0); break;
			}
		}
		else {
			// Scaling to fit
			if(img.width > width)
				scale = width / img.width;
			else
				scale = 1;
			
			if((img.height * scale) > height){
				scale = height / img.height;
			}
			
			//console.log("ImgSize: (" + img.width + "," + img.height + ") Scale: " + scale);
			//document.getElementById("debug1").innerHTML = "ImgSize: (" + img.width + "," + img.height + ") Orient: " + orient + " Scale: " + scale.toFixed(2);

			canvas.width = img.width * scale;
			canvas.height = img.height * scale;
			ctx.transform(scale, 0, 0, scale, 0, 0);
		}
		ctx.drawImage(img, 0, 0);
	}
	
	this.imageLoaded = function(){
		//alert("imageLoaded:" + this.name + " Orient: " + this.orient);
		var img = this.img;

		//console.log("imageLoaded: " + String(this.width) + " " + String(img.width) + " Orient: " + this.orient);
		this.canvasDraw(this.canvas, this.img, this.orient, this.width, this.height);

		// Preview
		this.preview.width = this.status.clientWidth;
		this.preview.height = this.status.clientHeight;
		this.canvasDraw(this.preview, this.img, this.orient, this.preview.width, this.preview.height);
		
		this.status.innerHTML = "";
		this.status.appendChild(this.preview);

		this.canvas.toBlob(createObjDelegate(this, this.canvasLoaded), this.file.type, 1.0);
	}
	
	this.fileLoaded2 = function(oFREvent){
		this.img.onload = createObjDelegate(this, this.imageLoaded);
		this.img.src = oFREvent.target.result;
	}
	
	this.readImage = function(){
		oFReader = new FileReader(), rFilter = /^(?:image\/bmp|image\/cis\-cod|image\/gif|image\/ief|image\/jpeg|image\/jpeg|image\/jpeg|image\/pipeg|image\/png|image\/svg\+xml|image\/tiff|image\/x\-cmu\-raster|image\/x\-cmx|image\/x\-icon|image\/x\-portable\-anymap|image\/x\-portable\-bitmap|image\/x\-portable\-graymap|image\/x\-portable\-pixmap|image\/x\-rgb|image\/x\-xbitmap|image\/x\-xpixmap|image\/x\-xwindowdump)$/i;
		oFReader.onload = createObjDelegate(this, this.fileLoaded2);
		oFReader.readAsDataURL(this.file);
	}

	this.fileLoaded1 = function(e){
		// Determine image orientation from EXIF data in a JPEG file
		this.orient = 0;
		
		var view = new DataView(e.target.result);
		if(view.getUint16(0, false) != 0xFFD8){
			this.readImage();
		}

		var length = view.byteLength, offset = 2;
		while(offset < length){
			if(view.getUint16(offset+2, false) <= 8) return -1;
			var marker = view.getUint16(offset, false);
			offset += 2;
			if(marker == 0xFFE1){
				if(view.getUint32(offset += 2, false) != 0x45786966){
					this.readImage();
				}

				var little = view.getUint16(offset += 6, false) == 0x4949;
				offset += view.getUint32(offset + 4, little);
				var tags = view.getUint16(offset, little);
				offset += 2;
				for(var i = 0; i < tags; i++){
					if(view.getUint16(offset + (i * 12), little) == 0x0112){
						this.orient = view.getUint16(offset + (i * 12) + 8, little);
						this.readImage();
					}
				}
			}
			else if((marker & 0xFF00) != 0xFF00){
				break;
			}
			else { 
				offset += view.getUint16(offset, false);
			}
		}
		this.readImage();
	}


	this.resizePicureFile = function(){
		var fileTypes = ["image/jpeg", "image/png", "image/gif"];

		//alert("resizePicureFile:" + this.name + " " + this.onchangeDisable);
		if(!this.onchangeDisable){
			f = this.fileinput.files.length;
			this.file = this.fileinput.files[f - 1];
			if(!this.file) return;

			//alert("FileType: " + this.file.type);
			if(!fileTypes.includes(this.file.type))
				return;

			oFReader = new FileReader(), rFilter = /^(?:image\/bmp|image\/cis\-cod|image\/gif|image\/ief|image\/jpeg|image\/jpeg|image\/jpeg|image\/pipeg|image\/png|image\/svg\+xml|image\/tiff|image\/x\-cmu\-raster|image\/x\-cmx|image\/x\-icon|image\/x\-portable\-anymap|image\/x\-portable\-bitmap|image\/x\-portable\-graymap|image\/x\-portable\-pixmap|image\/x\-rgb|image\/x\-xbitmap|image\/x\-xpixmap|image\/x\-xwindowdump)$/i;
			oFReader.onload = createObjDelegate(this, this.fileLoaded1);
			oFReader.readAsArrayBuffer(this.file);
		}
	}

	this.button.onclick = createObjDelegate(this, this.selectFile);
	this.fileinput.onchange = createObjDelegate(this, this.resizePicureFile);
	this.status.addEventListener("dragover", function(event){ event.preventDefault(); }, true);
	this.status .addEventListener("drop", createObjDelegate(this, this.droppedFiles), true);
}

// Form File line
function FormInputFile(name, mimeTypes){
	// alert("FormInputFile: Start");

	//mimeTypes = "application/gpx+xml";
	html = "<input id='" + name + "' name='" + name + "' type='file' size='30' accept='" + mimeTypes + "'></input>";
	document.writeln(html);
}

function FormInputFiles(name, mimeTypes){
	// alert("FormInputFile: Start");

	//mimeTypes = "application/gpx+xml";
	html = "<input id='" + name + "' name='" + name + "[]' multiple type='file' size='30' accept='" + mimeTypes + "'></input>";
	document.writeln(html);
}

function htmlToText(html){
	var tmp = document.createElement("DIV");
	tmp.innerHTML = html;
	return tmp.textContent || tmp.innerText || "";
}

var itemsUpdateNum = 0;

function itemsFetchDataAndSet(url){
	var xmlhttp = new XMLHttpRequest();
	xmlhttp.open('GET', url + "&cmd=getUpdateNum", true);
	xmlhttp.onreadystatechange = function(){
		if(xmlhttp.readyState==4 && xmlhttp.status == 200){
			updateNum = parseInt(xmlhttp.responseText);
			//console.log("Update: " + itemsUpdateNum + " " + updateNum);

			if((itemsUpdateNum != 0) && (updateNum > itemsUpdateNum)){
				//console.log("Update: get contents: " + url + "&cmd=getMessages");
				var xmlhttp1 = new XMLHttpRequest();
				xmlhttp1.open('GET', url + "&cmd=getMessages", true);
				xmlhttp1.onreadystatechange = function(){
					//console.log("Update: getmessages returned");
					if(xmlhttp1.readyState==4 && xmlhttp1.status == 200){
						m = document.getElementById('messages');
						//console.log("UpdateContents: " + m.offsetHeight + " " + m.scrollHeight + " " + m.scrollTop + " " + (m.scrollHeight - m.offsetHeight));
						if(m.scrollTop >= (m.scrollHeight - m.offsetHeight))
							atBottom = 1;
						else
							atBottom = 0;
							
						m.innerHTML = xmlhttp1.responseText;
						if(atBottom)
							m.scrollTop = m.scrollHeight;

						//notificationSend("TandemClub news", url);
					}
				}
				xmlhttp1.send("");
			}
			itemsUpdateNum = updateNum;
		}
	};
	xmlhttp.send("");
}

function itemsFetchDataAndSetLoop(url, repeatTimeMs){
	var running = false;

	if(!running){
		running = true;
		function run(){
//			console.log("fetchDataAndSetLoop.run");
			itemsFetchDataAndSet(url);
		}
		setInterval(run, repeatTimeMs);
	}
};

function reloadUrl(url){
	var xmlhttp = new XMLHttpRequest();
	xmlhttp.open('GET', url, true);
	xmlhttp.onreadystatechange = function(){
	}
	xmlhttp.setRequestHeader("Pragma", "no-cache");
	xmlhttp.send("");
}

// Notifications
class WsNotifications {
	constructor(){
		this.init();
	}
	
	init(){
		if("serviceWorker" in navigator){
			navigator.serviceWorker.ready.then(serviceWorkerRegistration => {
				serviceWorkerRegistration.pushManager.getSubscription().then(subscription => {
					this.sendSubscriptionToBackEnd(subscription);
				})
			});
			//this.notificationWorkerEnable(1);
		}
	}
	
	enable(on){
		//console.log("WsNotifications.enable(" + on + ")");

		if(on){
			if(!("Notification" in window)){
				alert("This browser does not support desktop notification");
			}

			// Let's check whether notification permissions have already been granted
			else if(Notification.permission === "granted"){
				// If it's okay let's create a notification
				//var notification = new Notification("Notifications enabled");
				this.notificationWorkerEnable(on);
			}

			// Otherwise, we need to ask the user for permission
			else if(Notification.permission !== "denied"){
				Notification.requestPermission(function(obj=this, permission){
					// If the user accepts, let's create a notification
					if(permission === "granted"){
						var notification = new Notification("Notifications enabled");
						obj.notificationWorkerEnable(on);
					}
				});
			}
			else {
				console.log("WsNotifications::enable: " + Notification.permission);
			}
		}
		else {
			if(!("Notification" in window))
				return;

			this.notificationWorkerEnable(on);
		}
	}
	
	enabled(){
		return (Notification.permission === "granted");
	}

	notificationWorkerEnable(on){
		if(on){
			if(!("serviceWorker" in navigator)){
				return new Error("No Service Worker support");
			}
			if(!("PushManager" in window)) {
				return new Error("No Push API Support");
			}

			navigator.serviceWorker.register("service.js")
				.then(function(swReg) {
					//console.log("Service Worker is registered", swReg);
				})
				.catch(function(error) {
					console.error("Service Worker Error", error);
				});
		}
		else {
			//console.log("Service Workers are unregistered");
			navigator.serviceWorker.getRegistrations().then(function(registrations){
				for(let registration of registrations){ registration.unregister(); }});
		}

		return 0;
	}


	send(title, url){
		//console.log("notificationSend");
		var notification = new Notification(title);
		notification.onclick = function(event){
			event.preventDefault(); // prevent the browser from focusing the Notification's tab
			window.open(url, 'items').focus();
		}
	}
	
	enableButtonCreate(parent = 0, text, userEnabled, group=""){
		var b;
		
		//console.log("enableButtonCreate: " + userEnabled + ", " + group);
		if(1 || !userEnabled || !this.enabled()){
			if(parent == 0)
				parent = document.currentScript.parentElement;

			b = new HtmlNode(parent, "button", {type: 'button', name: 'notifications'}, text);
			b.setAttribute("title", "Enable notifications. You will have to confirm with the browser's dialog");

			b.addEventListener("click", createObjDelegate(this, this.enableButtonEnable, {obj: b, on: 1, group: group}), false);
		}
	}
	
	enableButtonEnable(args){
		//console.log("enableButtonEnable: " + args.on + ", " + args.group);
		this.enable(args.on);
		this.userEnable(args.on, args.group);
		args.obj.style.visibility = "hidden";
	}

	enableCheckboxCreate(parent = 0, userEnabled){
		var b;
		
		if(parent == 0)
			parent = document.currentScript.parentElement;

		b = new HtmlNode(parent, "input", {name: 'notifications', type: 'checkbox'});
		b.setAttribute("title", "Enable/disable notifications. You will have to confirm with the browser's dialog");

		if(userEnabled && this.enabled())
			b.checked = true;

		b.addEventListener("click", createObjDelegate(this, this.enableCheckboxEnable, b), false);
	}
	
	enableCheckboxEnable(b){
		this.enable(b.checked);
		this.userEnable(b.checked ? 1:0);
	}

	userEnable(on, group=""){
		var body = { on: on, group: group };
		return fetch("/notification?cmd=userEnable", {
			method: 'POST',
			headers: { 'Content-Type': 'application/json' },
			body: JSON.stringify(body)
		})
		.then(function(response){
			if(!response.ok){
				throw new Error('Bad status code from server.');
			}
		})
		.catch(function (error) {
			console.log(error)
		});
	}

	serviceWorkerReady(serviceWorker){
		var sub = serviceWorker.pushManager.getSubscription();
		//console.log("serviceWorkerReady: " + sub);
		this.sendSubscriptionToBackEnd(serviceWorker.pushManager.getSubscription());
	}
	
	sendSubscriptionToBackEnd(subscription){
		return fetch("/notification?cmd=subscribe", {
			method: 'POST',
			headers: {
				'Content-Type': 'application/json'
			},
			body: JSON.stringify(subscription)
		})
		.then(function(response){
			if(!response.ok){
				throw new Error('Bad status code from server.');
			}
		})
		.catch(function (error) {
			console.log(error)
		});
	}
}

// If the text within the current element overflows, add a "more ..." text or given text.
function textOverflowAddMore(html=""){
	if(html == "")
		html = "more ...";

	el = document.currentScript.parentElement;
	if(el.clientHeight < el.scrollHeight){
		if(0){
			// make height a multiple of the text line height
			elStyle = window.getComputedStyle(el);
			lineHeight = 1.5 * parseInt(elStyle.getPropertyValue('font-size'));
			el.style.height = (lineHeight * Math.floor(el.clientHeight / lineHeight)).toString() + "px";
		}
		elMore = document.createElement('span');
		elMore.innerHTML = html;
		elMore.style.position = "absolute";
		elMore.style.bottom = 0;
		elMore.style.right = 0;
		elMore.style.paddingLeft = "1em";
		elMore.style.zindex = "-1";
		elMore.style.backgroundColor = "white";
		el.appendChild(elMore);
		el.style.position = "relative";
	}
}

function loadPageTrigger(time, url){
    setTimeout(function(url){ window.location=url; }, time, url);
}

function wsButton(cssClass, icon, iconAlt, text, url, target=""){
	if(target != "")
		target = "target='" + target + "'";

	document.write("<a class='" + cssClass + "' href='" + url + "' " + target + ">");
	if(icon != "")
		document.write("<img src='" + icon + "' alt='" + iconAlt + "'/>");
	if(text != "")
		document.write(text);
	document.write("</a>");
}

function setTheme(theme){
	fetch("/management?cmd=themes&style=" + theme);
	setInterval(function(){ location.reload(); }, 1000);
}

function cardNumberFormat(obj){
	//alert("cardNumberFormat: " + obj.value);
	num = obj.value;
	num = num.replace(/[^\d]+/g, "");
	num = num.substring(0, 16);
	num = num.match(/.{1,4}/g);
	num = num ? num.join(" "): "";

	obj.value = num;
}

function inputNumbersOnly(obj){
	num = obj.value;
	num = num.replace(/[^\d]+/g, "");
	obj.value = num;
}

function wsSearchField(){
	document.write("<div class='WsSearch'><input id='searchText' placeholder='Search'/><button onClick='wsSearchDo();'></button></div>");
	var ele = document.getElementById("searchText");
	ele.addEventListener("keyup", function(event){
		if(event.keyCode === 13){
			event.preventDefault();
			window.location = "/search?search=" + ele.value;
		}
	});
}

function wsSearchDo(){
	var ele = document.getElementById("searchText");
	if(ele){
		window.location = "/search?search=" + ele.value;
	}
}

var wsNotifications = new WsNotifications();

window.onerror = function(msg, url, line){
	var req = new XMLHttpRequest();
	var params = "msg=" + encodeURIComponent(msg) + '&url=' + encodeURIComponent(url) + "&line=" + line;

	req.open("POST", "/management?cmd=clientError");
	req.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	req.send(params);
  
	return false;
}

// Selection list with wild card selector
class editorSelectWild {
	constructor(parent=null, name="", options={}, wild="", value="", num=0, tip=""){
		if(parent === null)
			this.parent = document.currentScript.parentElement;
		else
			this.parent = parent;

		//console.log("editorSelectWild: Value: ", value, " Options: ", options);
		this.value = value;
		
		this.optionList = [];
		for(var i = 0; i < options.length; i++){
			if(Array.isArray(options[i]))
				this.optionList.push(options[i]);
			else
				this.optionList.push([options[i], options[i], ""]);
		}
		
		this.div = new HtmlNode(this.parent, "div");
		this.eWild = new HtmlNode(this.div, "input", { "name": name + "_wild", "title": tip, "value": wild });
		this.eWild.style.display = "block";
		this.eWild.style.width = "7em";
		if(num)
			this.eSelect = new HtmlNode(this.div, "select", { "name": name + "[]", "title": tip, "multiple":1, property: "vectList", "size": num});
		else
			this.eSelect = new HtmlNode(this.div, "select", { "name": name, "title": tip });

		this.eSelect.style.display = "block";

		this.updateSelect();
		
		this.eWild.addEventListener("input", createObjDelegate(this, this.wildChanged));
	}
	
	updateSelect(){
		while(this.eSelect.firstChild){
			this.eSelect.removeChild(this.eSelect.firstChild);
		}

		var wild = null;
		if(this.eWild.value != ""){
			wild = new RegExp("^"+ this.eWild.value, "i");
		}
			
		for(var i in this.optionList){
			if(wild && !this.optionList[i][0].match(wild))
				continue;

			var className = "";
			if(this.optionList[i].length > 2)
				var className = this.optionList[i][2];

			var opt = new HtmlNode(this.eSelect, "option", {"className": className, "value": this.optionList[i][1]}, this.optionList[i][0]);

			if(Array.isArray(this.value) && this.value.includes(this.optionList[i][1]))
				opt.setAttribute("selected", 1);
			else if(!Array.isArray(this.value) && (this.value == this.optionList[i][1]))
				opt.setAttribute("selected", 1);
		}
	}
	
	wildChanged(){
		this.updateSelect();
	}
}
